<?php
/*
	e.g. http://video.google.com/videoplay?docid=-123456789123654798
*/
if(!defined('PHPMELODY'))
	die('Restricted Access!');

function get_info($url)
{
	$video_data = array();
	
	$url = trim($url);
	$str1 = explode("docid=",$url);
	$docid = $str1[1];
	if(strstr($docid,"&"))
	{
		$str1 = explode("&",$docid);
		$docid = $str1[0];
	}
	$target_url = 'http://video.google.com/videofeed?docid='.$docid;

	$error = 0;
	if(ini_get('allow_url_fopen') == 1)
	{
		$video_data = @file($target_url);
		if($video_data === false)
			$error = 1;
	}
	//	something wrong? use cURL
	if( (ini_get('allow_url_fopen') == 1 && $error == 1) || ini_get('allow_url_fopen') == 0)
	{
		if(function_exists('curl_init'))
		{
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $target_url);
			curl_setopt($ch, CURLOPT_HEADER, 0);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.7.5) Gecko/20041107 Firefox/1.0');
			$video_data = curl_exec($ch);
			$errormsg = curl_error($ch);
			curl_close($ch);
			
			if($errormsg != '')
			{
				echo $errormsg;
				return false;
			}
		}
	}
	if(!is_array($video_data))
	{
		$video_data = explode("\n", $video_data);
	}
	return $video_data;
}


function get_flv($video_data)
{
	$flv_link = "";
	
	$arr_length = count($video_data);
	
	for($i = 0; $i < $arr_length; $i++)
	{
		if(preg_match('/<media:content url=\"(.*?)\" type=\"application\/x-shockwave-flash\" (.*?)\/>/i', $video_data[$i], $matches) != 0)
		{
			$str = explode("videoUrl=", $matches[1]);
			$flv_link = urldecode($str[1]);
		}
	}
	return $flv_link;
}


function get_thumb_link($url) 
{
	$thumb_link = '';
	
	$error = 0;
	if(ini_get('allow_url_fopen') == 1)
	{	
		$contents = @file_get_contents($url);
		if($contents === false)
			$error = 1;
	}
	//	something wrong? use cURL
	if( (ini_get('allow_url_fopen') == 1 && $error == 1) || ini_get('allow_url_fopen') == 0)
	{
		if(function_exists('curl_init'))
		{
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_HEADER, 0);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.7.5) Gecko/20041107 Firefox/1.0');
			$contents = curl_exec($ch);
			$errormsg = curl_error($ch);
			curl_close($ch);
			
			if($errormsg != '')
			{
				echo $errormsg;
				return false;
			}
		}
	}

	$str1 = explode('thumbnailUrl\x3d', $contents);
	$str2 = explode('\x26docid', $str1[1]);
	$thumb_link = urldecode($str2[0]);
	
	return $thumb_link;
}

function video_details($video_data, $url, &$info) 
{
	//	video id;
	$target = trim($url);
	$str1 = explode("docid=",$target);
	$docid = $str1[1];
	if(strstr($docid,"&"))
	{
		$str1 = explode("&",$docid);
		$docid = $str1[0];
	}
	$info['yt_id'] = $docid;
	
	$contents = implode("\n", $video_data);
	$contents = str_replace("\n", '', $contents);
	//	title
	if(preg_match("/<media:title>(.*?)<\/media:title>/", $contents, $matches) != 0)
	{
		$info['video_title'] = $matches[1];
	}
	//	description
	if(preg_match("/<media:description>(.*?)<\/media:description>/", $contents, $matches) != 0)
	{
		$info['description'] = $matches[1];
	}
	//	video length
	if(preg_match("/<media:player url=\"(.*?)\" \/>/", $contents, $matches) != 0)
	{
		$str1 = explode("len=", $matches[1]);
		if(strstr($str1[1], "&"))
		{
			$str1 = explode("&", $str1[1]);
			$info['yt_length'] = $str1[0];
		}
	}
		
	//	mp4 link
	if(preg_match_all('/<media:content url=\"(.*?)\" type=\"(.*?)\" (.*?)\/>/', $contents, $matches) != 0)
	{
		foreach($matches[1] as $k => $v_url)
		{
			if(strstr($v_url, '.mp4?') !== FALSE)
			{
				$info['mp4'] = $v_url;
				break;
			}
		}
	}
	
	$info['url_flv'] = get_flv($video_data);
	$info['yt_thumb'] = get_thumb_link($url);
	//	direct link
	$direct = $url;
	if(strstr($direct, "http://") === FALSE)
		$direct = "http://" . $direct;

	$info['direct'] = $direct;
}

function download_thumb($thumbnail_link, $upload_path, $video_uniq_id) {

	$last_ch = substr($upload_path, strlen($upload_path)-1, strlen($upload_path));
	if($last_ch != "/")
		$upload_path .= "/"; 

	//	get image ext.
	$ext = ".jpg";	//	force image type

	//	thumbnail's name is based on the video's unique id.
	$thumb_name = $video_uniq_id . "-1" . $ext;
	
	//	kill the execution if a file with this name was found;
	if(is_file( $upload_path . $thumb_name )) {
		//	slick chances for this to happen
		return FALSE;
	}
	
	$error = 0;
	if( ini_get('allow_url_fopen') == 1 )
	{
		// try copying it... if it fails, go to backup method.
		if(!copy($thumbnail_link, $upload_path . $thumb_name ))
		{
			//	create a new image
			list($img_width, $img_height, $img_type, $img_attr) = @getimagesize($thumbnail_link);

			$image = '';

			switch($img_type)
			{
				default:
				case 1:
					//GIF
					$image = imagecreatefromgif($thumbnail_link);
					$ext = ".gif";
				break;
				case 2:
					//JPG
					$image = imagecreatefromjpeg($thumbnail_link);
					$ext = ".jpg";
				break;  
				case 3:
					//PNG
					$image = imagecreatefrompng($thumbnail_link);
					$ext = ".png";
				break;
			}
			
			$resource = @imagecreatetruecolor($img_width, $img_height);
			if( function_exists('imageantialias'))
			{
				@imageantialias($resource, true);
				
			}
			
			@imagecopyresampled($resource, $image, 0, 0, 0, 0, $img_width, $img_height, $img_width, $img_height);
			@imagedestroy($image);
		}
		
		$thumb_name = $video_uniq_id . "-1" . $ext;
		
		$img_type = 2;
		switch($img_type)
		{
			default:
			case 1:
				//GIF
				@imagegif($resource, $upload_path . $thumb_name);
			break;
			case 2:
				//JPG
				@imagejpeg($resource, $upload_path . $thumb_name);
			break;  
			case 3:
				//PNG
				@imagepng($resource, $upload_path . $thumb_name);
			break;
		}
		
		if($resource === '')
			$error = 1;
	}
	elseif( (ini_get('allow_url_fopen') == 1 && $error == 1) || ini_get('allow_url_fopen') == 0 ) 	//	Use cURL;
	{	
		if ( function_exists('curl_init') ) {

			$ch = curl_init();
			$timeout = 0;
			curl_setopt ($ch, CURLOPT_URL, $thumbnail_link);
			curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
			
			// Getting binary data
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_BINARYTRANSFER, 1);
			
			$image = curl_exec($ch);
			curl_close($ch);
			
			//	create & save image;
			$img_res = @imagecreatefromstring($image);
			if($img_res === false)
				return FALSE;
			
			$img_width = imagesx($img_res);
			$img_height = imagesy($img_res);
			
			$resource = @imagecreatetruecolor($img_width, $img_height);
			
			if( function_exists('imageantialias'))
			{
				@imageantialias($resource, true); 
			}
			
			@imagecopyresampled($resource, $img_res, 0, 0, 0, 0, $img_width, $img_height, $img_width, $img_height);
			@imagedestroy($img_res);
		
			switch($ext)
			{
				case ".gif":
					//GIF
					@imagegif($resource, $upload_path . $thumb_name);
				break;
				case ".jpg":
					//JPG
					@imagejpeg($resource, $upload_path . $thumb_name);
				break;  
				case ".png":
					//PNG
					@imagepng($resource, $upload_path . $thumb_name);
				break;
			}
		} 
	}
	return $upload_path . $thumb_name;
}

/*
	MAIN
	it is the only function called outside this script
 */
function do_main(&$video_details, $url)
{
	$video_data = get_info($url);
	video_details($video_data, $url, $video_details);
}

?>