<?php

/*
	$url			should contain the direct link to video (e.g. http://www.metacafe.com/watch/1352794/best_cars_in_the_worlds/)
*/

if(!defined('PHPMELODY'))
	die('Restricted Access!');

function get_info($url)
{
	$video_data = array();
	
	$str1 = explode("/watch/", $url);
	$str2 = explode("/", $str1[1]);
	$video_id = $str2[0];
	
	$target_url = "http://www.metacafe.com/api/item/".$video_id;

	$error = 0;
	if(ini_get('allow_url_fopen') == 1)
	{
		$video_data = @file($target_url);
		if($video_data === false)
			$error = 1;
	}
	
	//	something wrong? use cURL
	if( (ini_get('allow_url_fopen') == 1 && $error == 1) || ini_get('allow_url_fopen') == 0)
	{
		if(function_exists('curl_init'))
		{
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $target_url);
			curl_setopt($ch, CURLOPT_HEADER, 0);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.7.5) Gecko/20041107 Firefox/1.0');
			$video_data = curl_exec($ch);
			$errormsg = curl_error($ch);
			curl_close($ch);
			
			if($errormsg != '')
			{
				echo $errormsg;
				return false;
			}
		}
	}
	if(!is_array($video_data))
	{
		$video_data = explode("\n", $video_data);
	}
	
	return $video_data;
}

function get_flv($url)
{
	$flv_link = "";

	$str1 = explode("/watch/", $url);
	$str2 = explode("/", $str1[1]);
	$video_id = $str2[0];
	

	$error = 0;
	if(ini_get('allow_url_fopen') == 1)
	{	
		$contents = @file($url);
		if($contents === false)
		{
			$error = 1;
		}
	}
	
	if( (ini_get('allow_url_fopen') == 1 && $error == 1) || ini_get('allow_url_fopen') == 0)
	{
		if(function_exists('curl_init'))
		{
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_HEADER, 0);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.7.5) Gecko/20041107 Firefox/1.0');
			$contents = curl_exec($ch);
			$errormsg = curl_error($ch);
			curl_close($ch);
			
			if($errormsg != '')
			{
				echo $errormsg;
				return false;
			}
			$contents = explode("\n", $contents);
		}
	}
	//	extract flv link
	$arr_length = count($contents);

	for($i = 0; $i < $arr_length; $i++)
	{
		$contents[$i] = str_replace( array("\n", "\t", "\r"), '', $contents[$i]);
		if(preg_match('/&mediaURL=(.*?)&gdaKey=(.*?)&/i', $contents[$i], $matches) != 0)
		{	
			$flv_link = urldecode($matches[1]);
			$flv_link .= '?__gda__='.$matches[2];
		}
	}
	$flv_link = str_replace("\\", "", $flv_link);
	//$flv_link = str_replace("http://v.mccont.com", "http://akvideos.metacafe.com", $flv_link);
	
	return $flv_link;
}

function get_thumb_link($video_data) 
{
	$thumb_link = '';
	$arr_length = count($video_data);
	for($i = 0; $i < $arr_length; $i++)
	{
		if(preg_match('/<img src=\"(.*?)\"(.*?)\/>/i', $video_data[$i], $matches) != 0)
		{
			$link = $matches[1];
			if(strlen($link) > 5)
			{
				$tmp = explode("/", $link);
				
				$tmp[6] = "1111111";
				$tmp[7] = "directors_cut";
				$tmp[8] = "1111111";
				$tmp[9] = "1111111";
				$tmp[10] = "111111111111.jpg";
				
				$link = implode("/", $tmp);
				break;			
			}
		}
	}
	$thumb_link = $link;
	return $thumb_link;
}

function video_details($video_data, $url, &$info) 
{
	$arr_length = count($video_data);
	for($i = 0; $i < $arr_length; $i++)
	{
		$video_data[$i] = str_replace( array("\n", "\t", "\r"), '', $video_data[$i]);

		//	video id
		if(preg_match("/<id>(.*?)<\/id>/", $video_data[$i], $matches) != 0)
		{			
			$info['yt_id'] = $matches[1];
		}
		//	duration
		elseif(preg_match("/<media:content (.*?) duration=\"(.*?)\" \/>/i", $video_data[$i], $matches) != 0)
		{
			$info['yt_length'] = $matches[2];
		}
		//	video title
		elseif(preg_match("/<media:title>(.*?)<\/media:title>/i", $video_data[$i], $matches) != 0)
		{
			$info['video_title'] = $matches[1];
		}	
		//	tags
		elseif(preg_match("/<media:keywords>(.*?)<\/media:keywords>/i", $video_data[$i], $matches) != 0)
		{
			$info['tags'] = $matches[1];
		}
		//	description
		elseif(preg_match("/<media:description>(.*?)<\/media:description>/i", $video_data[$i], $matches) != 0)
		{
			$info['description'] = $matches[1];
		}

	}
	
	$info['url_flv'] = get_flv($url);
	$info['yt_thumb'] = get_thumb_link($video_data);
	//	direct link
	$direct = $url;
	if(strstr($direct, "http://") === FALSE)
		$direct = "http://" . $direct;

	$info['direct'] = $direct;
}

function download_thumb($thumbnail_link, $upload_path, $video_uniq_id) {
	
	$last_ch = substr($upload_path, strlen($upload_path)-1, strlen($upload_path));
	if($last_ch != "/")
		$upload_path .= "/"; 

	//	get image ext.
	//$ext = substr($thumbnail_link, strlen($thumbnail_link)-4, strlen($thumbnail_link));
	$tmp = explode(".", $thumbnail_link);
	$ext = $tmp[ count($tmp)-1 ];
	$ext = "." . $ext;

	//	force image type: jpg
	$ext = ".jpg";

	//	thumbnail's name is based on the video's unique id.
	$thumb_name = $video_uniq_id . "-1" . $ext;

	//	kill the execution if a file with this name was found;
	if(is_file( $upload_path . $thumb_name )) {
		//	slick chances for this to happen
		return FALSE;
	}
	
	$error = 0;
	if( ini_get('allow_url_fopen') == 1 )
	{
		// try copying it... if it fails, go to backup method.
		if(!copy($thumbnail_link, $upload_path . $thumb_name ))
		{
			//	create a new image
			list($img_width, $img_height, $img_type, $img_attr) = @getimagesize($thumbnail_link);

			$image = '';
			
			switch($img_type)
			{
				case 1:
					//GIF
					$image = imagecreatefromgif($thumbnail_link);
					$ext = ".gif";
				break;
				case 2:
					//JPG
					$image = imagecreatefromjpeg($thumbnail_link);
					$ext = ".jpg";
				break;  
				case 3:
					//PNG
					$image = imagecreatefrompng($thumbnail_link);
					$ext = ".png";
				break;
			}
			
			$resource = @imagecreatetruecolor($img_width, $img_height);
			if( function_exists('imageantialias'))
			{
				@imageantialias($resource, true); 
			}
			
			@imagecopyresampled($resource, $image, 0, 0, 0, 0, $img_width, $img_height, $img_width, $img_height);
			@imagedestroy($image);
		}
		
		$thumb_name = $video_uniq_id . "-1" . $ext;
		
		$img_type = 2;
		switch($img_type)
		{
			case 1:
				//GIF
				@imagegif($resource, $upload_path . $thumb_name);
			break;
			case 2:
				//JPG
				@imagejpeg($resource, $upload_path . $thumb_name);
			break;  
			case 3:
				//PNG
				@imagepng($resource, $upload_path . $thumb_name);
			break;
		}
		
		if($resource === '')
			$error = 1;
	}
	elseif( (ini_get('allow_url_fopen') == 1 && $error == 1) || ini_get('allow_url_fopen') == 0 ) 	//	Use cURL;
	{
		if ( function_exists('curl_init') ) {

			$ch = curl_init();
			$timeout = 0;
			curl_setopt ($ch, CURLOPT_URL, $thumbnail_link);
			curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
			
			// Getting binary data
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_BINARYTRANSFER, 1);
			
			$image = curl_exec($ch);
			curl_close($ch);
			
			//	create & save image;
			$img_res = @imagecreatefromstring($image);
			if($img_res === false)
				return FALSE;
			
			$img_width = imagesx($img_res);
			$img_height = imagesy($img_res);
			
			$resource = @imagecreatetruecolor($img_width, $img_height);
			
			if( function_exists('imageantialias'))
			{
				@imageantialias($resource, true); 
			}
			
			@imagecopyresampled($resource, $img_res, 0, 0, 0, 0, $img_width, $img_height, $img_width, $img_height);
			@imagedestroy($img_res);
		
			switch($ext)
			{
				case ".gif":
					//GIF
					@imagegif($resource, $upload_path . $thumb_name);
				break;
				case ".jpg":
					//JPG
					@imagejpeg($resource, $upload_path . $thumb_name);
				break;  
				case ".png":
					//PNG
					@imagepng($resource, $upload_path . $thumb_name);
				break;
			}
		} 
	}
	return $upload_path . $thumb_name;
}

/*
	MAIN
	it is the only function called outside this script
 */
function do_main(&$video_details, $url)
{
	$video_data = get_info($url);
	video_details($video_data, $url, $video_details);
}

?>