<?php

/*
	e.g. http://www.myspace.com/index.cfm?fuseaction=vids.individual&videoid=123556
*/

if(!defined('PHPMELODY'))
	die('Restricted Access!');


/*
	This function is used to retrieve information about the video and
	save it for later use.
 */
function get_info($url)
{
	$video_data = array();
	
	//$url = str_replace(array( "VideoID=", "VIDEOID="), "videoid=", $url);
	$url = strtolower($url);
	$str1 = explode("videoid=",$url);
	
	$str2 = $str1[1];
	if(strstr($str2,"&"))
	{
		$str1 = explode("&",$str2);
		$str2 = $str1[0];
	}
	$target_url = "http://mediaservices.myspace.com/services/rss.ashx?type=video&videoID=".$str2;

	$error = 0;
	if(ini_get('allow_url_fopen') == 1)
	{
		$video_data = @file($target_url);
		if($video_data === false)
			$error = 1;
	}
	
	//	something wrong? use cURL
	if( (ini_get('allow_url_fopen') == 1 && $error == 1) || ini_get('allow_url_fopen') == 0)
	{
		if(function_exists('curl_init'))
		{
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $target_url);
			curl_setopt($ch, CURLOPT_HEADER, 0);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.7.5) Gecko/20041107 Firefox/1.0');
			$video_data = curl_exec($ch);
			$errormsg = curl_error($ch);
			curl_close($ch);
			
			if($errormsg != '')
			{
				echo $errormsg;
				return false;//$errormsg;
			}
		}
	}
	if(!is_array($video_data))
	{
		$video_data = explode("\n", $video_data);
	}
	
	return $video_data;
}

/*
	This function is used to extract the flv link
 */
function get_flv($video_data)
{
	$flv_link = "";

	$arr_length = count($video_data);
	for($i = 0; $i < $arr_length; $i++)
	{
		if (strstr($video_data[$i],"<media:content"))
		{
			$buffer2 = $video_data[$i];
			$str1 = explode('url="',$buffer2);
			$str3 = explode('"',$str1[1]);
			$flv_link = $str3[0];
			break;
		}
	}
	return $flv_link;
}

/*
	This function is used to extract the thumbnail link
 */
function get_thumb_link($video_data) 
{
	$thumb_link = '';
	$arr_length = count($video_data);
	for($i = 0; $i < $arr_length; $i++)
	{
		if (strstr($video_data[$i],"<media:thumbnail"))
		{
			$buffer2 = $video_data[$i];
			$str1 = explode('url="',$buffer2);
			$str3 = explode('"',$str1[1]);
			$thumb_link = $str3[0];
			break;
		}
	}
	$thumb_link = str_replace("thumb0", "thumb1", $thumb_link);
	
	return $thumb_link;
}

/*
	This function is used to fill in the global $video_details array with all
	the information available
 */
function video_details($video_data, $url, &$info) 
{
	$arr_length = count($video_data);
	for($i = 0; $i < $arr_length; $i++)
	{
		//	video id
		if(strstr($video_data[$i],"<myspace:itemID>"))
		{
			$buffer2 = $video_data[$i];
			$str1 = explode(">", $buffer2);
			$str3 = explode("<", $str1[1]);
			$info['yt_id'] = $str3[0];
		}
		//	video length
		elseif (strstr($video_data[$i],"<media:content>"))
		{
			$buffer2 = $video_data[$i];
			$str1 = explode('duration="', $buffer2);
			$str3 = explode('"', $str1[1]);
			$info['yt_length'] = $str3[0];
		}
	}
	$info['url_flv'] = get_flv($video_data);
	$info['yt_thumb'] = get_thumb_link($video_data);
	//	direct link
	$direct = $url;
	if(strstr($direct, "http://") === FALSE)
		$direct = "http://" . $direct;

	$info['direct'] = $direct;
	
}

/*
	This function is used to download the video's thumbnail and save it on the server
 */
function download_thumb($thumbnail_link, $upload_path, $video_uniq_id) {
	
	$last_ch = substr($upload_path, strlen($upload_path)-1, strlen($upload_path));
	if($last_ch != "/")
		$upload_path .= "/"; 

	//	get image ext.
	//$ext = substr($thumbnail_link, strlen($thumbnail_link)-4, strlen($thumbnail_link));
	$tmp = explode(".", $thumbnail_link);
	$ext = $tmp[ count($tmp)-1 ];
	$ext = "." . $ext;

	//	force image type: jpg
	$ext = ".jpg";

	//	thumbnail's name is based on the video's unique id.
	$thumb_name = $video_uniq_id . "-1" . $ext;
	
	//	kill the execution if a file with this name was found;
	if(is_file( $upload_path . $thumb_name )) {
		//	slick chances for this to happen
		return FALSE;
	}
	
	$error = 0;
	if( ini_get('allow_url_fopen') == 1 )
	{
		// try copying it... if it fails, go to backup method.
		if(!copy($thumbnail_link, $upload_path . $thumb_name ))
		{
			//	create a new image
			list($img_width, $img_height, $img_type, $img_attr) = @getimagesize($thumbnail_link);

			$image = '';
			
			switch($img_type)
			{
				case 1:
					//GIF
					$image = imagecreatefromgif($thumbnail_link);
					$ext = ".gif";
				break;
				case 2:
					//JPG
					$image = imagecreatefromjpeg($thumbnail_link);
					$ext = ".jpg";
				break;  
				case 3:
					//PNG
					$image = imagecreatefrompng($thumbnail_link);
					$ext = ".png";
				break;
			}
			
			$resource = @imagecreatetruecolor($img_width, $img_height);
			if( function_exists('imageantialias'))
			{
				@imageantialias($resource, true); 
			}
			
			@imagecopyresampled($resource, $image, 0, 0, 0, 0, $img_width, $img_height, $img_width, $img_height);
			@imagedestroy($image);
		}
		
		$thumb_name = $video_uniq_id . "-1" . $ext;
		
		$img_type = 2;
		switch($img_type)
		{
			case 1:
				//GIF
				@imagegif($resource, $upload_path . $thumb_name);
			break;
			case 2:
				//JPG
				@imagejpeg($resource, $upload_path . $thumb_name);
			break;  
			case 3:
				//PNG
				@imagepng($resource, $upload_path . $thumb_name);
			break;
		}
		
		if($resource === '')
			$error = 1;
	}
	elseif( (ini_get('allow_url_fopen') == 1 && $error == 1) || ini_get('allow_url_fopen') == 0 ) 	//	Use cURL;
	{	
		if ( function_exists('curl_init') ) {

			$ch = curl_init();
			$timeout = 0;
			curl_setopt ($ch, CURLOPT_URL, $thumbnail_link);
			curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
			
			// Getting binary data
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_BINARYTRANSFER, 1);
			
			$image = curl_exec($ch);
			curl_close($ch);
			
			//	create & save image;
			$img_res = @imagecreatefromstring($image);
			if($img_res === false)
				return FALSE;
			
			$img_width = imagesx($img_res);
			$img_height = imagesy($img_res);
			
			$resource = @imagecreatetruecolor($img_width, $img_height);
			
			if( function_exists('imageantialias'))
			{
				@imageantialias($resource, true); 
			}
			
			@imagecopyresampled($resource, $img_res, 0, 0, 0, 0, $img_width, $img_height, $img_width, $img_height);
			@imagedestroy($img_res);
		
			switch($ext)
			{
				case ".gif":
					//GIF
					@imagegif($resource, $upload_path . $thumb_name);
				break;
				case ".jpg":
					//JPG
					@imagejpeg($resource, $upload_path . $thumb_name);
				break;  
				case ".png":
					//PNG
					@imagepng($resource, $upload_path . $thumb_name);
				break;
			}
		} 
	}
	return $upload_path . $thumb_name;
}

/*
	MAIN
	it is the only function called outside this script
 */
function do_main(&$video_details, $url)
{
	$video_data = get_info($url);
	video_details($video_data, $url, $video_details);
}

?>